/**
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.portletcontainer.test.portlet2;

import javax.portlet.*;

import java.io.BufferedReader;
import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Enumeration;

/**
 * Created by The eXo Platform SAS 
 * Author : Roman Pedchenko
 *          roman.pedchenko@exoplatform.com.ua
 */

public class TestForm extends GenericPortlet {

  
  protected void doView(RenderRequest renderRequest, RenderResponse renderResponse) throws PortletException, IOException {
    renderResponse.setContentType("text/html; charset=UTF-8");
    PrintWriter w = renderResponse.getWriter();
    
    if (renderRequest.getParameter("result") != null) {
      w.println("<h3>result:</h3>");
      w.println("<pre>" + renderRequest.getParameter("result") + "</pre>");
    }
    PortletURL actionURL = renderResponse.createActionURL();
    w.println("<form action='" + actionURL.toString() + "' name='portletForm' method='POST'>");
    w.println("<input type='text' name='text' value='some data'>");
    w.println("<input type='file' name='file'>");
    w.println("<input type='submit' value='click me!'>");
    w.println("</form>");
  }

  public void processAction(ActionRequest actionRequest, ActionResponse actionResponse)  throws PortletException, IOException {
    String res = "Stream:\n";
    InputStream is = actionRequest.getPortletInputStream();
    res = res + " -- stream: " + is + "\n";
    if (is != null) {
      res = res + " -- available: " + is.available() + "\n -- data:\n    ";
      try {
        int i;
        while((i = is.read()) >= 0)
          res = res + (char) i;
      } catch (EOFException e) {}
    }
    is.close();
/*
    String res = "Reader:<br>\n";
    BufferedReader br = actionRequest.getReader();
    res = res + " -- reader: " + br + "<br>\n";
    if (br != null) {
      res = res + " -- ready: " + br.ready() + "<br>\n";
      res = res + "  <blockquote>\n";
      String s = null;
      while((s = br.readLine()) != null) {
        res = res + s + "\n";
      }
      res = res + "  </blockquote><br>\n";
    }
    br.close();
*/
    actionResponse.setRenderParameter("result", res);
  }

}
