/**
 * Created by The eXo Platform SAS 
 * Author : Alexey Zavizionov
 *          alexey.zavizionov@exoplatform.com.ua
 */
package org.exoplatform.services.portletcontainer.test.portlet2;

import javax.portlet.*;
import javax.xml.namespace.QName;

import java.io.IOException;
import java.io.PrintWriter;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageEncoder;
import java.awt.Color;
import java.awt.image.BufferedImage;
import java.awt.Graphics2D;

public class TestServeResource2 extends GenericPortlet {

  
  protected void doView(RenderRequest renderRequest, RenderResponse renderResponse)
      throws PortletException, IOException {
    //System.out.println("In doView method of TestPortletNEW...");
    
    renderResponse.setContentType("text/html; charset=UTF-8");
    PrintWriter w = renderResponse.getWriter();
    w.println(((new Exception()).getStackTrace()[0]).getMethodName());
    w.println("<br>");
    
    ResourceURL resourceURL = renderResponse.createResourceURL();
    resourceURL.setParameter("goal", "image");
    w.println("<p><a href=\"" + resourceURL.toString() + "\">resourceURL</a></p>");
    
    resourceURL = renderResponse.createResourceURL();
    resourceURL.setParameter("goal", "image2");
    w.println("<p><img src=\"" + resourceURL.toString() + "\"/></p>");
    
    PortletContext context = getPortletContext();
    PortletRequestDispatcher rd = context.getRequestDispatcher("/WEB-INF/script.jsp");
    rd.include(renderRequest, renderResponse);

    w.println("----------------------------------------<br>");
  }    
    
  protected void doEdit(RenderRequest renderRequest, RenderResponse renderResponse)
      throws PortletException, IOException {
    renderResponse.setContentType("text/html; charset=UTF-8");
    PrintWriter w = renderResponse.getWriter();
    w.println(((new Exception()).getStackTrace()[0]).getMethodName());
  }

  protected void doHelp(RenderRequest renderRequest, RenderResponse renderResponse)
      throws PortletException, IOException {
    renderResponse.setContentType("text/html; charset=UTF-8");
    PrintWriter w = renderResponse.getWriter();
    w.println(((new Exception()).getStackTrace()[0]).getMethodName());
  }

  public void processAction(ActionRequest actionRequest, ActionResponse actionResponse)
      throws PortletException, IOException {
  }

  public void render(RenderRequest renderRequest, RenderResponse renderResponse)
      throws PortletException, IOException {
    super.render(renderRequest, renderResponse);
  }

  public void serveResource(ResourceRequest request, ResourceResponse response) throws PortletException, IOException {
    String goal = request.getParameter("goal");
    if (goal != null && goal.equals("image")) {
      response.setContentType("image/jpeg");
      Graphics2D graphics;
      java.io.OutputStream stream = response.getPortletOutputStream();
      JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(stream);
      BufferedImage bi = new BufferedImage(50, 20, BufferedImage.TYPE_BYTE_INDEXED);
      graphics = bi.createGraphics();
      graphics.setColor(Color.white);
      graphics.fillRect(0, 0, bi.getWidth(), bi.getHeight());
      graphics.setColor(Color.red);
      graphics.drawChars("\u041f\u0418\u0417\u0414\u0415\u0426".toCharArray(),0,6,0,10);
      encoder.encode(bi);
    } else if (goal != null && goal.equals("image2")) {
      response.setContentType("image/jpeg");
      Graphics2D graphics;
      java.io.OutputStream stream = response.getPortletOutputStream();
      JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(stream);
      BufferedImage bi = new BufferedImage(50, 50, BufferedImage.TYPE_BYTE_INDEXED);
      graphics = bi.createGraphics();
      graphics.setColor(Color.white);
      graphics.fillRect(0, 0, bi.getWidth(), bi.getHeight());
      graphics.setColor(Color.green);
      graphics.drawLine( 0, 24,  9, 24);
      graphics.drawLine( 9, 24, 19,  0);
      graphics.drawLine(19,  0, 29, 49);
      graphics.drawLine(29, 49, 39, 24);
      graphics.drawLine(39, 24, 49, 24);
      encoder.encode(bi);
    } else {
      response.setContentType("text/html; charset=UTF-8");
      PrintWriter w = response.getWriter();
      w.println("MARKUP FROM SERVEFRAGMENT");
    }
    
//    MyEventPub sampleAddress = new MyEventPub();
//    sampleAddress.setStreet("myStreet");
//    sampleAddress.setCity("myCity");
//    response.setEvent(new QName("MyEventPub2"), sampleAddress);
  }

}
