/**
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.portletcontainer.test.listeners;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import org.exoplatform.container.StandaloneContainer;

/**
 * Created by The eXo Platform SAS  .
 *
 * @author <a href="mailto:roman.pedchenko@exoplatform.com.ua">Roman Pedchenko</a>
 * @version $Id$
 */

/**
 * Servlet context listener class is intended to catch context initialization and to set up
 * StandaloneContainer.
 */
public class AppListener implements ServletContextListener {

  /**
   * Creates stand-alone container when context have just initialized.
   *
   * @param sce servlet context event
   */
  public final void contextInitialized(final ServletContextEvent sce) {
    try {
      ServletContext ctx = sce.getServletContext();
      Object[][] components = {{ServletContext.class.getName(), ctx}};
      // it's needed to switch off default behavior -- searching for /conf/portal/configuration.xml in all
      // available jars
     // StandaloneContainer.setConfigurationURL(null);
      StandaloneContainer standaloneContainer = StandaloneContainer.getInstance(this.getClass().getClassLoader(),
        components);
    } catch (Exception e) {
      System.out.println(" !!! AppListener.contextInitialized exception: " + e);
      e.printStackTrace();
    }
  }

  /**
   * Does nothing. Just an empty interface implementation.
   *
   * @param sce servlet context event
   */
  public final void contextDestroyed(final ServletContextEvent sce) { }

}
