/**
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.portletcontainer.test.listeners;

import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;
import org.exoplatform.container.ExoContainerContext;
import org.exoplatform.services.portletcontainer.helper.WindowInfosContainer;

/**
 * Created by The eXo Platform SAS .
 *
 * @author <a href="mailto:roman.pedchenko@exoplatform.com.ua">Roman Pedchenko</a>
 * @date 2007-04-20
 */

/**
 * Http session listener class is intended to catch session destroying and to remove window infos
 * container dedicated to given session.
 */
public class SessionListener implements HttpSessionListener {

  /**
   * Default constructor.
   *
   * @param se session event
   */
  public void sessionCreated(final HttpSessionEvent se) { }

  /**
   * Drops window info objects right before session is about to be destroyed.
   *
   * @param se session event
   */
  public final void sessionDestroyed(final HttpSessionEvent se) {
    WindowInfosContainer.removeInstance(ExoContainerContext.getCurrentContainer(), se.getSession().getId());
  }

}
