/**
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

package org.exoplatform.services.portletcontainer.pci;

import java.util.HashMap;
import java.util.Map;

import javax.portlet.PortletMode;
import javax.portlet.WindowState;

/**
 * @author: Roman Pedchenko
 * @email:  roman.pedchenko@exoplatform.com.ua
 * @version: $Id$
 */

public class ResourceOutput extends RenderOutput {
  
  // from event
  private PortletMode nextMode;
  private WindowState nextState;

  // from action
  private Map renderParameters = new HashMap();
  private byte[] portletState;

  private String charset;
  
  // from event
  public PortletMode getNextMode() {
    return nextMode;
  }

  public void setNextMode(PortletMode nextMode) {
    this.nextMode = nextMode;
  }

  public WindowState getNextState() {
    return nextState;
  }

  public void setNextState(WindowState nextState) {
    this.nextState = nextState;
  }
  
  // from action
  public Map getRenderParameters() {
    return renderParameters;
  }

  public void setRenderParameters(Map renderParameters) {
    this.renderParameters = renderParameters;
  }

  public void setRenderParameter(String key, String value) {
    renderParameters.put(key, new String[] {value});
  }

  public void setRenderParameters(String key, String[] values) {
    renderParameters.put(key, values);
  }

  public byte[] getPortletState() {
    return portletState;
  }

  public void setPortletState(byte[] portletState) {
    this.portletState = portletState;
  }
  
  public void setCharacterEncoding(String charset) {
    this.charset = charset;
  }
 
  public String getCharacterEncoding() {
    return charset;
  }
 
}
