package org.exoplatform.services.portletcontainer.plugins.pc.filter;


import org.exoplatform.services.portletcontainer.pci.model.Portlet;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.EventRequest;
import javax.portlet.EventResponse;
import javax.portlet.PortletException;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.ResourceRequest;
import javax.portlet.ResourceResponse;
import javax.portlet.filter.*;

import java.util.Collection;
import java.util.Iterator;
import java.io.IOException;


/**
 * Copyright 2001-2007 The eXo platform SAS  All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by the Exo Development team.
 * Author : Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 * Date: 17 nov. 2003
 * Time: 21:21:35
 */
public class PortletFilterChainImpl implements FilterChain {

  private Collection filters;
	private Iterator iterator;
	private Portlet portlet;

	public PortletFilterChainImpl(Collection filters, Portlet p) {
	  this.filters = filters;
		this.portlet = p;
	}

	public Iterator getFiltersIterator() {
		return filters.iterator();
	}

	public void restart() {
		this.iterator = filters.iterator();
	}

  public void doFilter(ActionRequest request, ActionResponse response) throws IOException, PortletException {
    if (iterator.hasNext()) {
      ActionFilter portletFilter = (ActionFilter) iterator.next();
      portletFilter.doFilter(request, response, this);
    }
  }
  
  public void doFilter(EventRequest request, EventResponse response) throws IOException, PortletException {
    if (iterator.hasNext()) {
      EventFilter portletFilter = (EventFilter) iterator.next();
      portletFilter.doFilter(request, response, this);
    }
  }
  
  public void doFilter(RenderRequest request, RenderResponse response) throws IOException, PortletException {
    if (iterator.hasNext()) {
      RenderFilter portletFilter = (RenderFilter) iterator.next();
      portletFilter.doFilter(request, response, this);
    }
  }
  
  public void doFilter(ResourceRequest request, ResourceResponse response) throws IOException, PortletException {
    if (iterator.hasNext()) {
      ResourceFilter portletFilter = (ResourceFilter) iterator.next();
      portletFilter.doFilter(request, response, this);
    }
  }

}
