/**
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by The eXo Platform SAS 
 * Author : Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 * Date: Jul 28, 2003
 * Time: 10:18:25 PM
 */
package org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp;


import java.util.List;
import java.util.Map;
import java.util.Enumeration;
import java.util.Collection;
import java.util.Set;
import java.util.Iterator;

import javax.portlet.*;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponseWrapper;

import org.exoplatform.container.ExoContainer;
import org.exoplatform.services.portletcontainer.pci.EventOutput;
import org.exoplatform.services.portletcontainer.pci.Output;
import org.exoplatform.services.portletcontainer.pci.Input;
import org.exoplatform.services.portletcontainer.pci.ResourceInput;
import org.exoplatform.services.portletcontainer.pci.model.Portlet;
import org.exoplatform.services.portletcontainer.pci.PortletURLFactory;
import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.PortletURLImp;
import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.ResourceURLImp;
import org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp.ResponseContext;


public class PortletResponseImp extends HttpServletResponseWrapper
    implements PortletResponse {

  protected ResponseContext resCtx;
  protected ExoContainer cont_;
  protected List customWindowStates_;//TODO
  protected Input input_;
  protected Output output_;
  protected boolean redirectionPossible_;
  protected boolean sendRedirectAlreadyOccured_;
  protected Enumeration supportedWindowState_;
  protected Portlet portletDatas_;
  protected boolean isCurrentlySecured_;
  protected String windowId_;
  
  
  public PortletResponseImp(ResponseContext resCtx) {
    super(resCtx.getHttpServletResponse());
    this.cont_ = resCtx.getCont();
    this.input_ = resCtx.getInput();
    this.output_ = resCtx.getOutput();
    this.customWindowStates_ = resCtx.getCustomWindowState();
    this.supportedWindowState_ = resCtx.getPortalContext().getSupportedWindowStates();
    this.redirectionPossible_ = true;
    this.sendRedirectAlreadyOccured_ = false;
    this.portletDatas_ = resCtx.getPortletDatas();
    this.windowId_ = resCtx.getWindowID();
    this.isCurrentlySecured_ = resCtx.isSecure();
  }

  public void addProperty(String s, String s1) {
    output_.addProperty(s, s1);
  }

  public void setProperty(String s, String s1) {
    output_.addProperty(s, s1);
  }

  protected String getProperty(String s) {
    return (String) output_.getProperties().get(s);
  }

  protected void removeProperty(String s) {
    output_.getProperties().remove(s);
  }

  public String getNamespace() {
    return "I" + (windowId_.replace('-', 'I')).replace('/', 'I') + "I";
  }

  public String encodeURL(String path) {
    if (!path.startsWith("/") && !path.startsWith("http://")) {
      throw new IllegalArgumentException("Path must be started with / or http://") ; 
    }
    // made for TCK com.sun.ts.tests.portlet.api.javax_portlet.PortletRequestDispatcher.ResponseMethodsMiscMiscTestPortlet on weblogic 9.2
    // was: return path;
    if (super.encodeURL(path) == null) {
      return path;
    }    
    return super.encodeURL(path);
  }
  
  //adds for jsr-286
  public Output getOutput() {
    return output_;
  }
  
  public void setOutput(Output o) {
    this.output_ = o;
  }
  
  public boolean isSendRedirectAlreadyOccured() {
    return sendRedirectAlreadyOccured_;
  }
  
  public void setProperty(String key, String value, int scope) {
    // TODO Auto-generated method stub
  }
  
  public void addProperty(Cookie cookie) {
    super.addCookie(cookie);
  }
  
  public void addProperty(String key, org.w3c.dom.Element element) {
    // TODO does it work correctly??
    addProperty(new Cookie(key, element.toString()));
  }

}
