/**
 * Copyright 2001-2007 The eXo Platform SAS  All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by The eXo Platform SAS
 * Author : Roman Pedchenko <roman.pedchenko@exoplatform.com.ua>
 */
package org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp;

import java.util.Collection;
import java.util.List;

import javax.portlet.PortalContext;
import javax.portlet.PortletContext;
import javax.servlet.http.HttpServletRequest;

import org.exoplatform.services.portletcontainer.helper.PortletWindowInternal;
import org.exoplatform.services.portletcontainer.pci.Input;
import org.exoplatform.services.portletcontainer.pci.model.Portlet;

public class RequestContext {

  private HttpServletRequest httpServletRequest_;
  private PortalContext portalContext_;
  private PortletContext portletContext_;
  private PortletSessionImp session_;
  private Portlet portletDatas_;
  private Input input_;
  private PortletWindowInternal portletWindowInternal_;
  private List securityContraints_;
  private List userAttributes_;
  private List customPortletModes_;
  private List customWindowStates_;
  private Collection roles_;
  private Collection supportedContents_;

  public RequestContext(HttpServletRequest httpServletRequest,
												PortalContext portalContext,
												PortletContext portletContext,
												PortletSessionImp session,
//												Portlet portletDatas,
                        Input input,
												PortletWindowInternal portletWindowInternal,
												List securityContraints,
                        List userAttributes,
												List customPortletModes,
												List customWindowStates,
                        Collection roles,
												Collection supportedContents) {
		this.httpServletRequest_ = httpServletRequest;
		this.portalContext_ = portalContext;
		this.portletContext_ = portletContext;
		this.session_ = session;
		this.portletDatas_ = ((PortletContextImpl)portletContext).getPortlet();
		this.input_ = input;
		this.portletWindowInternal_ = portletWindowInternal;
		this.securityContraints_ = securityContraints;
		this.userAttributes_ = userAttributes;
		this.customPortletModes_ = customPortletModes;
		this.customWindowStates_ = customWindowStates;
		this.roles_ = roles;
		this.supportedContents_ = supportedContents;
	}

  public HttpServletRequest getHttpServletRequest() {
    return httpServletRequest_;
  }

  public PortalContext getPortalContext() {
    return portalContext_;
  }

  public PortletContext getPortletContext() {
	  return portletContext_;
	}

  public PortletSessionImp getSession() {
	  return session_;
	}

  public Portlet getPortletDatas() {
    return portletDatas_;
  }

  public Input getInput() {
    return input_;
  }

  public PortletWindowInternal getPortletWindowInternal() {
    return portletWindowInternal_;
  }

  public List getSecurityContraints() {
    return securityContraints_;
  }

  public List getUserAttributes() {
    return userAttributes_;
  }

  public List getCustomPortletModes() {
    return customPortletModes_;
  }

  public List getCustomWindowStates() {
    return customWindowStates_;
  }

  public Collection getRoles() {
    return roles_;
  }

  public Collection getSupportedContents() {
    return supportedContents_;
  }

}
