/**
 * Copyright 2001-2007 The eXo Platform SAS  All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by The eXo Platform SAS 
 * Author : Roman Pedchenko <roman.pedchenko@exoplatform.com.ua>
 */
package org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp;

import java.util.Locale;
import javax.portlet.ResourceResponse;
import org.apache.commons.lang.StringUtils;
import org.exoplatform.services.portletcontainer.pci.ResourceOutput;

public class ResourceResponseImp extends MimeResponseImp implements ResourceResponse {

  public ResourceResponseImp(ResponseContext resCtx) {
    super(resCtx);
  }

  public void setContentType(String contentType) {
    if (contentType != null && contentType.indexOf(';') >= 0) {
      String s = StringUtils.split(contentType, ';')[1].trim();
      contentType = StringUtils.split(contentType, ';')[0].trim();
      if (s.toLowerCase().startsWith("charset="))
        setCharacterEncoding(s.substring(8));
    }
    super.setContentType(contentType);
  }

  public void setCharacterEncoding(String charset) {
    ((ResourceOutput) output_).setCharacterEncoding(charset);
  }
 
  public void setContentLength(int len) {
    super.setContentLength(len);
  }  
  
  public void setLocale(Locale loc) {
    super.setLocale(loc);
  }
  
}
