package org.exoplatform.services.portletcontainer.imp.Portlet286;

import javax.portlet.PortletMode;
import javax.portlet.ResourceURL;
import javax.portlet.WindowState;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.exoplatform.services.portletcontainer.PortletContainerException;
import org.exoplatform.services.portletcontainer.imp.EmptyResponse;
import org.exoplatform.services.portletcontainer.pci.ExoWindowID;
import org.exoplatform.services.portletcontainer.pci.RenderOutput;
import org.exoplatform.services.portletcontainer.pci.ResourceOutput;
import org.exoplatform.test.mocks.servlet.MockHttpSession;
import org.exoplatform.test.mocks.servlet.MockServletRequest;
import org.exoplatform.test.mocks.servlet.MockServletResponse;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.io.*;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

public class TestCacheability extends BaseTest2 {
  
  
  private static Log log = ExoLogger.getLogger("org.exoplatform.services.portletcontainer.imp.Portlet286.TestCacheability");
  
  
  public TestCacheability(String s) {
    super(s);
  }
  
  /**Max Shaposhnik  @09.2007
   * PLT 13.7
   * Attempts to create URLs that are 
   * not of type FULL or are not resource URLs in the current, or a downstream 
   * response must result in an IllegalStateException
   */
  
  public void testCacheability() throws PortletContainerException {
    log.info("testCacheability...");
    MockServletRequest request = new MockServletRequest(new MockHttpSession(), Locale.US, true);
    HttpServletResponse response = new MockServletResponse(new EmptyResponse());    
    ((ExoWindowID)resourceInput.getInternalWindowID()).setPortletName("PortletToTestCacheability");
    resourceInput.setPortletMode(PortletMode.VIEW);
    Map pms = new HashMap();
    pms.put("test", "1");
    resourceInput.setRenderParameters(pms);
    
    ResourceOutput o2 = portletContainer.serveResource(request, response, resourceInput);
    String rURL = new String(o2.getContent());
    String temp = org.exoplatform.Constants.CACHELEVEL_PARAMETER + "=";

    pms.put("test", "2");
    resourceInput.setRenderParameters(pms);
    resourceInput.setCacheability(rURL.substring(rURL.indexOf(temp) + temp.length()));//, rURL.indexOf("|", rURL.indexOf(temp) + temp.length())));
    ResourceOutput o3 = portletContainer.serveResource(request, response, resourceInput);
    assertTrue(new String(o3.getContent()).startsWith("OK"));
    
    pms.put("test", "3");
    resourceInput.setRenderParameters(pms);
    ResourceOutput o4 = portletContainer.serveResource(request, response, resourceInput);
    assertTrue(new String(o4.getContent()).indexOf(ResourceURL.FULL) > -1);
    log.info("Done."); 
  }
  
  /**
   * PLT 13.7
   * Creating other URLs, e.g. resource URLs of type PAGE or 
   * action or render URLs, must result in an IllegalStateException
   * 
   */
  
  public void testCacheabilityLimitCreatingOtherURLs() throws PortletContainerException {
    log.info("testCacheabilityLimitCreatingOtherURLs...");
    
    Map pms = new HashMap();
    
    MockServletRequest request = new MockServletRequest(new MockHttpSession(), Locale.US, true);
    HttpServletResponse response = new MockServletResponse(new EmptyResponse());    
    ((ExoWindowID)resourceInput.getInternalWindowID()).setPortletName("PortletToTestCacheability");
    
    resourceInput.setPortletMode(PortletMode.VIEW);
    pms.put("test", "7");
    resourceInput.setRenderParameters(pms);
    
    resourceInput.setCacheability(ResourceURL.FULL);
    ResourceOutput o2 = portletContainer.serveResource(request, response, resourceInput);
    assertTrue(new String(o2.getContent()).startsWith("OK"));
    log.info("Done.");
  }
  
  

}
