/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portletcontainer.imp.Portlet286;


import javax.portlet.PortletMode;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.portletcontainer.PortletContainerException;
import org.exoplatform.services.portletcontainer.imp.EmptyResponse;
import org.exoplatform.services.portletcontainer.pci.*;

import org.exoplatform.test.mocks.servlet.MockHttpSession;
import org.exoplatform.test.mocks.servlet.MockServletRequest;
import org.exoplatform.test.mocks.servlet.MockServletResponse;

import java.util.Locale;

/**
 * Created by The eXo Platform SAS
 * Author : Alexey Zavizionov
 *          alexey.zavizionov@exoplatform.com.ua
 * 24.04.2007  
 */
public class TestResourceServing extends BaseTest2{

  private static Log log = ExoLogger.getLogger("org.exoplatform.services.portletcontainer.imp.Portlet286.TestResourceServing");
  
	public TestResourceServing(String s) {
		super(s);
	}

  public void testResourceServing() throws PortletContainerException {
    log.info("testResourceServing...");
    MockServletRequest request = new MockServletRequest(new MockHttpSession(), Locale.US, true);
    HttpServletResponse response = new MockServletResponse(new EmptyResponse());    

    ((ExoWindowID)resourceInput.getInternalWindowID()).setPortletName("PortletToTestServeResource");
    resourceInput.setPortletMode(PortletMode.VIEW);
    
    ResourceOutput rO = portletContainer.serveResource(request, response, resourceInput);
    
    assertNotNull(rO.getContent());
    assertTrue(new String(rO.getContent()).startsWith("Everything is ok"));
    log.info("done.");
  }
  

}
