/**
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved. 
 * Please look at license.txt in info directory for more license detail.  
 */

package org.exoplatform.services.wsrp.consumer.portlets;

import java.util.ArrayList;
import java.util.List;
import java.util.HashMap;
import java.util.Collection;
import javax.portlet.PortletMode;
import javax.portlet.WindowState;

import org.exoplatform.container.ExoContainer;
import org.exoplatform.services.portletcontainer.pci.model.Portlet;
import org.exoplatform.services.portletcontainer.pci.model.Supports;
import org.exoplatform.services.portletcontainer.pci.model.DisplayName;
import org.exoplatform.services.portletcontainer.plugins.pc.PortletDataImp;
import org.exoplatform.services.wsrp.WSRPConstants;

/**
 * Created by The eXo Platform SAS
 * Author : Alexey Zavizionov
 *          alexey.zavizionov@exoplatform.com.ua
 * 07.06.2007  
 */
public class WSRPAdminPortletDataImp extends PortletDataImp {

  protected WSRPAdminPortlet portletObj = null;
  
  public WSRPAdminPortletDataImp(ExoContainer cont, HashMap adminPortletParams) {
    super(cont, null, null, new ArrayList());
    portlet_ = new Portlet();
    portlet_.setPortletName(WSRPConstants.WSRP_ADMIN_PORTLET_NAME);
    portlet_.setPortletClass(WSRPConstants.WSRP_ADMIN_PORTLET_CLASS);
      String portletTitle = null;
      if (adminPortletParams != null)
        portletTitle = (String)adminPortletParams.get(WSRPConstants.WAP_portletTitle);
      if (portletTitle == null)
        portletTitle = WSRPConstants.WSRP_ADMIN_PORTLET_NAME;
      List displayName = new ArrayList();
      DisplayName dn = new DisplayName();
      dn.setDisplayName(portletTitle);
      dn.setLang("en");
      displayName.add(dn);
    portlet_.setDisplayName(displayName);
      Supports supports = new Supports() ;
      supports.setMimeType("text/html") ;
    portlet_.setSupports(supports) ;
    portletObj = new WSRPAdminPortlet();
    portletObj.init(cont);
  }

  public WSRPAdminPortlet getPortletObject() {
    return portletObj;
  }

  public Collection getPortletModes(String markup) {
    if (markup.equals("text/html")) {
  	  ArrayList r = new ArrayList();
  	  r.add(PortletMode.VIEW);
  	  return r;
    }
    return null;
  }

  public boolean isModeSuported(String markup, PortletMode mode) {
  	return markup.equals("text/html") && (mode.equals(PortletMode.VIEW) || mode.equals(PortletMode.EDIT) || mode.equals(PortletMode.HELP));
  }

  public Collection getWindowStates(String markup) {
  	if (markup.equals("text/html")) {
  	  ArrayList r = new ArrayList();
  	  r.add(WindowState.NORMAL);
  	  r.add(WindowState.MINIMIZED);
  	  r.add(WindowState.MAXIMIZED);
  	  return r;
  	}
    return null;
  }

  public boolean isStateSupported(String markup, WindowState state) {
  	return markup.equals("text/html") && (state.equals(WindowState.NORMAL) || state.equals(WindowState.MINIMIZED) || state.equals(WindowState.MAXIMIZED));
  }

  public boolean getEscapeXml() { return true; }

}
