/**
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved. 
 * Please look at license.txt in info directory for more license detail.  
 */

package org.exoplatform.services.wsrp2.bind;

import java.rmi.RemoteException;

import org.exoplatform.container.ExoContainerContext;
import org.exoplatform.services.wsrp2.intf.WSRP_v2_Registration_PortType;
import org.exoplatform.services.wsrp2.producer.RegistrationOperationsInterface;
import org.exoplatform.services.wsrp2.type.Deregister;
import org.exoplatform.services.wsrp2.type.GetRegistrationLifetime;
import org.exoplatform.services.wsrp2.type.InvalidRegistrationFault;
import org.exoplatform.services.wsrp2.type.Lifetime;
import org.exoplatform.services.wsrp2.type.MissingParametersFault;
import org.exoplatform.services.wsrp2.type.ModifyRegistration;
import org.exoplatform.services.wsrp2.type.OperationFailedFault;
import org.exoplatform.services.wsrp2.type.OperationNotSupportedFault;
import org.exoplatform.services.wsrp2.type.Register;
import org.exoplatform.services.wsrp2.type.RegistrationContext;
import org.exoplatform.services.wsrp2.type.RegistrationData;
import org.exoplatform.services.wsrp2.type.RegistrationState;
import org.exoplatform.services.wsrp2.type.ResourceSuspendedFault;
import org.exoplatform.services.wsrp2.type.ReturnAny;
import org.exoplatform.services.wsrp2.type.SetRegistrationLifetime;
import org.exoplatform.services.wsrp2.type.UserContext;
/**
 * 
 * @author  Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 */
public class WSRP_v2_Registration_Binding_SOAPImpl implements WSRP_v2_Registration_PortType{

  private RegistrationOperationsInterface registrationOperationsInterface;

  public WSRP_v2_Registration_Binding_SOAPImpl() {
    registrationOperationsInterface = (RegistrationOperationsInterface) ExoContainerContext.getCurrentContainer().
        getComponentInstanceOfType(RegistrationOperationsInterface.class);
  }

  public RegistrationContext register(Register register) throws RemoteException, OperationFailedFault, MissingParametersFault {
    return registrationOperationsInterface.register(register.getRegistrationData());
  }

  public ReturnAny deregister(RegistrationContext context) throws RemoteException, InvalidRegistrationFault, OperationFailedFault {
    return registrationOperationsInterface.deregister(context);    
  }

  public RegistrationState modifyRegistration(ModifyRegistration modifyRegistration) throws RemoteException,ResourceSuspendedFault, InvalidRegistrationFault, OperationFailedFault, MissingParametersFault, OperationNotSupportedFault {
    return registrationOperationsInterface.modifyRegistration(modifyRegistration.getRegistrationContext(),
                                                              modifyRegistration.getRegistrationData());
  }
  
  public Lifetime getRegistrationLifetime(GetRegistrationLifetime getRegistrationLifetime) throws RemoteException, InvalidRegistrationFault, OperationFailedFault
  {
    return registrationOperationsInterface.getRegistrationLifetime(getRegistrationLifetime.getRegistrationContext(), getRegistrationLifetime.getUserContext());
  }
  
  public Lifetime setRegistrationLifetime(SetRegistrationLifetime setRegistrationLifetime) throws RemoteException, InvalidRegistrationFault, OperationFailedFault
  {
    return registrationOperationsInterface.setRegistrationLifetime(setRegistrationLifetime.getRegistrationContext(), setRegistrationLifetime.getUserContext(), setRegistrationLifetime.getLifetime());
  }
  
  public ReturnAny deregister(Deregister deregister) throws RemoteException, InvalidRegistrationFault, OperationFailedFault {
    return registrationOperationsInterface.deregister(deregister.getRegistrationContext(), deregister.getUserContext());
    
  }

}
