/**
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved. 
 * Please look at license.txt in info directory for more license detail.  
 */

package org.exoplatform.services.wsrp2.producer;

import org.exoplatform.services.wsrp2.type.BlockingInteractionResponse;
import org.exoplatform.services.wsrp2.type.EventParams;
import org.exoplatform.services.wsrp2.type.HandleEventsResponse;
import org.exoplatform.services.wsrp2.type.InteractionParams;
import org.exoplatform.services.wsrp2.type.MarkupParams;
import org.exoplatform.services.wsrp2.type.MarkupResponse;
import org.exoplatform.services.wsrp2.type.PortletContext;
import org.exoplatform.services.wsrp2.type.RegistrationContext;
import org.exoplatform.services.wsrp2.type.ResourceParams;
import org.exoplatform.services.wsrp2.type.ResourceResponse;
import org.exoplatform.services.wsrp2.type.ReturnAny;
import org.exoplatform.services.wsrp2.type.RuntimeContext;
import org.exoplatform.services.wsrp2.type.UserContext;

/**
 * @author  Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 */
public interface MarkupOperationsInterface {
  public MarkupResponse getMarkup(RegistrationContext registrationContext, 
                                  PortletContext portletContext, 
                                  RuntimeContext runtimeContext, 
                                  UserContext userContext, 
                                  MarkupParams markupParams) 
    throws java.rmi.RemoteException;
  
  public ResourceResponse getResource(RegistrationContext registrationContext, 
                                      PortletContext portletContext, 
                                      RuntimeContext runtimeContext, 
                                      UserContext userContext, 
                                      ResourceParams resourceParams)
    throws java.rmi.RemoteException;

    
  public BlockingInteractionResponse performBlockingInteraction(RegistrationContext registrationContext, 
                                                                PortletContext portletContext, 
                                                                RuntimeContext runtimeContext, 
                                                                UserContext userContext, 
                                                                MarkupParams markupParams, 
                                                                InteractionParams interactionParams) 
    throws java.rmi.RemoteException;
  
  
  public HandleEventsResponse processEvent(RegistrationContext registrationContext, 
                                           PortletContext portletContext, 
                                           RuntimeContext runtimeContext, 
                                           UserContext userContext, 
                                           MarkupParams markupParams, 
                                           EventParams eventParams) 
    throws java.rmi.RemoteException;
  
    
  public ReturnAny initCookie(RegistrationContext registrationContext,
                              UserContext userContext) 
    throws java.rmi.RemoteException;
  
  public ReturnAny initCookie(RegistrationContext registrationContext) 
    throws java.rmi.RemoteException;
    
  public ReturnAny releaseSessions(RegistrationContext registrationContext, 
                                   String[] sessionIDs,
                                   UserContext userContext) 
    throws java.rmi.RemoteException;
  
  
  public ReturnAny releaseSessions(RegistrationContext registrationContext, 
                                   String[] sessionIDs) 
    throws java.rmi.RemoteException;
  
}