/**
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved. 
 * Please look at license.txt in info directory for more license detail.  
 */

package org.exoplatform.services.wsrp2.utils;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.xml.namespace.QName;

import org.exoplatform.services.wsrp2.type.LocalizedString;
import org.exoplatform.services.wsrp2.type.NamedString;

/**
 * @author Mestrallet Benjamin
 *         benjmestrallet@users.sourceforge.net
 */
public class Utils {

  public static LocalizedString getLocalizedString(String value, String lang, String rn) {
    LocalizedString tmp = new LocalizedString();
    tmp.setValue(value);
    //tmp.setLang(lang);
    tmp.setResourceName(rn);
    return tmp;
  }

  public static LocalizedString getLocalizedString(String value, String lang) {
    LocalizedString tmp = new LocalizedString();
    tmp.setValue(value);
    //tmp.setLang(lang);
    return tmp;
  }

  public static NamedString getNamesString(String name, String value){
    NamedString tmp = new NamedString();
    tmp.setName(name);
    tmp.setValue(value);
    return tmp;
  }

  public static QName[] getQNameArray(List<QName> list) {
    if (list == null)
      return null;
    if (list.isEmpty())
      return new QName[]{};
    QName[] result = list.toArray(new QName[]{});
    return result;
  }

  public static List<QName> getQNameList(QName[] array) {
    if (array == null)
      return null;
    if (array.length == 0)
      return new ArrayList<QName>();
    List<QName> result = Arrays.asList(array);
    return result;
  }
  
}
